#!/bin/sh
#------------------------------------------------------------------------------
# main_Portforwardings.cgi - show all portforwarding rules
#
# Creation:     17.06.2002  tobig
# Last Update:  17.06.2002  tobig
#
#------------------------------------------------------------------------------

SEC_REALM='webtools'
SEC_ACTION='portfw'
. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'

if [ ! -f /proc/net/ip_masq/autofw ]
then
  echo "<title>Error</title></head><body $bt>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed Portforwarding (OPT_PORTFW)!"
  echo "</body></html>"
  exit 1
fi

hextoip () {
  i=0
  sum=0
  out=""
  
  for digit in `echo "$1" | sed 's/./& /g'`
  do
    i=`expr $i + 1`

    case "$digit" in
      A) digit=10;;
      B) digit=11;;
      C) digit=12;;
      D) digit=13;;
      E) digit=14;;
      F) digit=15;;
    esac
    
    sum=`expr $sum \* 16 + $digit`
    
    if [ "$i" -eq 2 ]
    then
      i=0
      out="$out$sum."
      sum=0
    fi
  done

  if [ "$num" ]
  then
    echo "$out" | sed 's/\.$//'
  else
    ip=`echo "$out" | sed 's/\.$//'`
    set -- `nslookup $ip | grep "^Name:"`
    echo "$2"
  fi
}

hextodec () {
  sum=0
  
  for digit in `echo "$1" | sed 's/./& /g'`
  do
    case "$digit" in
      A) digit=10;;
      B) digit=11;;
      C) digit=12;;
      D) digit=13;;
      E) digit=14;;
      F) digit=15;;
    esac
    
    sum=`expr $sum \* 16 + $digit`
  done
  echo "$sum"
}

myname=`basename $0`

if [ "$QUERY_STRING" = "shownames" ]
then
  show="<a href=\"$myname\">Show IPs</a>"
  num=''
else
  show="<a href=\"$myname?shownames\">Show Names</a>"
  num='yes'
fi

echo "<title>Portforwardings</title>"
echo "</head><body>"
echo "<h1>Portforwardings (OPT_WEBTOOLS)</h1>"
echo "<p>$show<h3>Single Ports</h3><p><table border=\"1\">"

start="yes"
while read prot laddr lport no raddr rport no2
do
  if [ "$start" ]
  then
    echo '<tr><th rowspan="2">Proto-<br>col</th><th colspan="2">Local</th><th colspan="2">Remote</th></tr>'
    echo '<tr><th>IP</th><th>Port</th><th>IP</th><th>Port</th></tr>'
    start=
  else
    echo "<tr><td>$prot</td><td>`hextoip $laddr`</td><td>$lport</td><td>`hextoip $raddr`</td><td>$rport</td></tr>"
  fi
done < /proc/net/ip_masq/portfw

echo "</table><h3>Portranges</h3><p><table border=\"1\">"

start="yes"
while read type prot ports no raddr no2
do
  if [ "$start" ]
  then
    echo '<tr><th rowspan="2">Proto-<br>col</th><th colspan="2">Local</th><th>Remote</th></tr>'
    echo '<tr><th>Low</th><th>High</th><th>IP</th></tr>'
    start=
  else
    case $prot in
       6) prot="TCP";;
      11) prot="UDP";;
    esac

    oldIFS="$IFS"
    IFS="/"
    set -- $ports
    ports=$1
    IFS="-"
    set -- $ports
    IFS="$oldIFS"

    echo "<tr><td>$prot</td><td>`hextodec $1`</td><td>`hextodec $2`</td><td>`hextoip $raddr`</td></tr>"
  fi
done < /proc/net/ip_masq/autofw

echo "</table></body></html>"
